using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UIElements;
using UnityEngine.EventSystems;

// idea: remove buttons & change font size if distance > than a certain amount

public class DynamicFontResize : MonoBehaviour
{
    private UIDocument uiDocument;
    [SerializeField] Katas.Experimental.WorldSpaceUIDocument worldSpaceUIDocument;
    private Camera _camera;
    private VisualElement root;
    public float currentdistance;

    public float tiny = 50;
    public float big = 65;

    public float mindistance = 2;
    public float maxdistance = 5;

    private Button[] buttons;

    public void Start() {
        _camera = Camera.main;
        worldSpaceUIDocument.onUIDocumentReady.AddListener(setUIDocument);
    }

    public void Update() {
        currentdistance = DistanceToCamera(this.gameObject.transform.position);
        if (currentdistance > mindistance) {
            root.Q<Label>("Actor").style.fontSize = big;
            root.Q<TextElement>("Dialogue").style.fontSize = big;
            root.Q<VisualElement>("Container").style.visibility = Visibility.Visible;
            worldSpaceUIDocument.RefreshPanelSize();
        }
        else {
            root.Q<Label>("Actor").style.fontSize = tiny;
            root.Q<TextElement>("Dialogue").style.fontSize = tiny;
            root.Q<VisualElement>("Container").style.visibility = Visibility.Hidden;
            worldSpaceUIDocument.RefreshPanelSize();
        }
    }

    private void setUIDocument() {
        uiDocument = GetComponent<UIDocument>();
        root = uiDocument.rootVisualElement;
    }

    private float DistanceToCamera(Vector3 worldPosition) =>
    Vector3.Distance(_camera.transform.position, worldPosition);

}
